;;;; clpm client source-registry.d
;;;;
;;;; This software is part of CLPM. See README.org for more information. See
;;;; LICENSE for license information.

(uiop:define-package #:clpm-cli/commands/client/source-registry.d
    (:use #:cl
          #:clpm-cli/common-args
          #:clpm-cli/commands/client/common
          #:clpm-cli/interface-defs
          #:named-readtables)
  (:import-from #:uiop
                #:*stderr*
                #:*stdout*)
  (:import-from #:cl-interpol)
  (:import-from #:clpm))

(in-package #:clpm-cli/commands/client/source-registry.d)

(in-readtable :interpol-syntax)

(define-string *help-text*
  "Print a form suitable for including in a file in ASDF's
source-registry.conf.d folder. This form will tell ASDF where to find the
client.

Place the outputs of this command in a file such as
~~~~/.config/common-lisp/source-registry.conf.d/20-clpm-client.conf")

(defparameter *client-source-registry.d-ui*
  (adopt:make-interface
   :name "clpm client source-registry.d"
   :summary "Common Lisp Project Manager"
   :usage "client source-registry.d [options]"
   :help *help-text*
   :contents (list *group-common*)))

(define-cli-command (("client" "source-registry.d") *client-source-registry.d-ui*) (args options)
  (declare (ignore args options))
  (if (clpm:client-asd-pathname)
      (write-string #?";; -*- mode: common-lisp; -*-
;; Auto generated by CLPM version ${(clpm:clpm-version)}
(:directory #P\"${(uiop:pathname-directory-pathname (clpm:client-asd-pathname))}\")
"
                    *stdout*)
      (progn
        (write-string "Unable to find the CLPM client. Consider installing it to your user data directory with `clpm client install`
"
                      *stderr*)
        (uiop:quit 1))))
